VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form FEditor 
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   165
   ClientTop       =   735
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox Text1 
      Height          =   1575
      Left            =   240
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   0
      Text            =   "FEditor.frx":0000
      Top             =   120
      Width           =   2475
   End
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   4020
      Top             =   2640
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.Menu mMain 
      Caption         =   "&File"
      Index           =   0
      Begin VB.Menu mFile 
         Caption         =   "&Open..."
         Index           =   0
      End
      Begin VB.Menu mFile 
         Caption         =   "-"
         Index           =   1
      End
      Begin VB.Menu mFile 
         Caption         =   "E&xit"
         Index           =   2
      End
   End
   Begin VB.Menu mMain 
      Caption         =   "&Edit"
      Index           =   1
      Begin VB.Menu mEdit 
         Caption         =   "Font &Dialog..."
         Index           =   0
      End
      Begin VB.Menu mEdit 
         Caption         =   "&Stock Font"
         Index           =   1
      End
   End
End
Attribute VB_Name = "FEditor"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' *********************************************************************
'  Copyright 1999 Karl E. Peterson, All Rights Reserved
'  http://www.mvps.org/vb
' *********************************************************************
'  Warning: This computer program is protected by copyright law and
'  international treaties. Unauthorized reproduction or distribution
'  of this program, or any portion of it, may result in severe civil
'  and criminal penalties, and will be prosecuted to the maximum
'  extent possible under the law.
' *********************************************************************
'  Author grants royalty-free rights to use this code within
'  compiled applications. Selling or otherwise distributing
'  this source code is not allowed without author's express
'  permission.
' *********************************************************************
Option Explicit

Private Declare Function GetStockObject Lib "gdi32" (ByVal nIndex As Long) As Long
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long

' SendMessage constants for font messages
Private Const WM_SETFONT = &H30
Private Const WM_GETFONT = &H31

' API stock font identifier constants
Private Const OEM_FIXED_FONT = 10
Private Const ANSI_FIXED_FONT = 11
Private Const ANSI_VAR_FONT = 12
Private Const SYSTEM_FONT = 13
Private Const DEVICE_DEFAULT_FONT = 14
Private Const SYSTEM_FIXED_FONT = 16

Private Sub Form_Load()
   Me.Caption = "Simple Editor"
   Set Me.Icon = Nothing
   Text1.Text = ""
   Call GetStockFont(Text1)
End Sub

Private Sub Form_Resize()
   On Error Resume Next
   Text1.Move 0, 0, Me.ScaleWidth, Me.ScaleHeight
End Sub

Private Sub mEdit_Click(Index As Integer)
   Select Case Index
      Case 0
         Call GetFont(Text1)
      Case 1
         Call GetStockFont(Text1)
   End Select
End Sub

Private Sub mFile_Click(Index As Integer)
   Select Case Index
      Case 0
         Call OpenFile
      Case 2
         Unload Me
   End Select
End Sub

Private Sub GetFont(txt As TextBox)
   With CommonDialog1
      .CancelError = True
      .Flags = cdlCFScreenFonts _
               Or cdlCFFixedPitchOnly _
               Or cdlCFForceFontExist
      On Error Resume Next
      .ShowFont
      If Err.Number = 0 Then
         txt.Font.Name = .FontName
         txt.Font.Size = .FontSize
      End If
   End With
End Sub

Private Sub GetStockFont(txt As TextBox)
   Dim hFont As Long
   hFont = GetStockObject(ANSI_FIXED_FONT)
   Call SendMessage(txt.hWnd, WM_SETFONT, hFont, False)
   Call DeleteObject(hFont)
End Sub

Private Sub OpenFile()
   Dim hFile As Long
   With CommonDialog1
      .CancelError = True
      .Filter = "Text Files (*.txt)|*.txt"
      .filename = ""
      .Flags = cdlOFNFileMustExist Or cdlOFNReadOnly
      On Error Resume Next
      .ShowOpen
      If Err.Number = 0 Then
         hFile = FreeFile
         Open .filename For Binary As #hFile
         Text1.Text = Input(LOF(hFile), #hFile)
         Close #hFile
      End If
   End With
End Sub
